<template>
  <v-row justify="center">
    <v-dialog
      v-model="usersImport"
      @keydown.esc="closeDialog"
      @click:outside="closeDialog"
      width="500px"
    >
      <v-card>
        <v-toolbar style="position: relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-file-import</v-icon
              ><b>Importar usuários</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon
                v-on="on"
                style="position: absolute; right: 15px"
                color="red"
                @click="closeDialog"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <v-card-text>
          <v-form>
            <v-container>
              <v-row>
                <v-col cols="12" md="12" justify="center" align="center">
                  <input
                    ref="uploadInput"
                    type="file"
                    accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                    class="uploadInput"
                  />
                  <v-btn
                    color="primary"
                    class="px-2 mt-6"
                    outlined
                    @click="handleImport"
                    elevation="0"
                    small
                  >
                    Selecionar arquivo
                    <v-icon right class="ml-3">mdi-file-import</v-icon>
                  </v-btn>
                </v-col>
                <v-col cols="12" md="12" justify="center" align="center">
                  <span>{{ file.name }}</span>
                </v-col>
                <v-col cols="12" md="12" justify="center" align="center">
                  <v-autocomplete
                    autofocus
                    required
                    style="max-width: 80%"
                    class="pa-0 ma-0"
                    v-model="selectedRole"
                    :items="roles"
                    fluid
                    label="Selecione o papel do usuário na entidade"
                    item-text="label"
                    item-value="id"
                    no-data-text="Nenhum papel encontrado"
                  ></v-autocomplete>
                  <v-btn
                    style="width: 30%"
                    class="p-8 text-body-2"
                    color="primary"
                    variant="text"
                    @click="dialog = true"
                  >
                    Importante
                  </v-btn>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions class="mt-n4 pb-6 pr-6">
          <v-spacer></v-spacer>
          <v-btn text @click="closeDialog">Cancelar</v-btn>
          <v-btn
            color="primary"
            elevation="0"
            @click="handleSave"
            :disabled="file.formData == null || selectedRole == ''"
            >Importar</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialog" width="480">
      <v-card>
        <v-card-title>Formatação do Arquivo</v-card-title>
        <v-divider></v-divider>
        <v-card-text class="pt-4" style="height: 100px">
          Atenção em relação ao formato do arquivo <strong>xlsx</strong> ou <strong>xls</strong> importado, o arquivo deve
          conter as colunas: <strong>'matriculation'</strong>, <strong>'name'</strong>,
          <strong>'document'</strong>, <strong>'enity'</strong>, <strong>'document_type'</strong> e
          <strong>'email'</strong>.
        </v-card-text>
        <v-card-actions>
          <v-space></v-space>
          <v-btn color="primary" block @click="dialog = false">OK</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import Management from '../../services/management'
import User from '../../services/user'

export default {
  name: 'UsersImport',
  components: {},
  data: () => ({
    file: {
      name: '',
      formData: null,
    },
    usersImport: false,
    selectedRole: '',
    roles: [],
    dialog: false,
  }),
  computed: {
    ...mapState('user', []),
  },
  methods: {
    ...mapMutations('user', ['UPDATE_BASE_SNACKBAR']),
    openDialog(roles) {
      this.roles = roles
      this.usersImport = true
    },
    closeDialog() {
      this.file = {
        name: '',
        formData: null,
      }
      this.usersImport = false
      this.selectedRole = ''
    },
    async handleImport() {
      this.$refs.uploadInput.onchange = async (event) => {
        const file = event.target.files[0]
        this.file.name = file.name
        const formData = new FormData()
        formData.append('userDocument', file)
        this.file.formData = formData
      }
      this.$refs.uploadInput.click()
    },

    async handleSave() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('usersImport').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.importUsers(
          entityId,
          actionId,
          this.selectedRole,
          this.file.formData
        )
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.closeDialog()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Usuário <b>importado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.$emit('usersImportedDone')
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Erro ao importar usuário!',
            icon: 'mdi-alert-circle',
            color: 'red',
          })
        }
      } catch (e) {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message: 'Erro ao importar usuário!',
          icon: 'mdi-alert-circle',
          color: 'red',
        })
      }
    },
  },
}
</script>

<style scoped>
.uploadInput {
  display: none;
}
</style>
